
	AREA    Example,CODE,READONLY

;-----------------------------------------
; CALL: extern void biquad(int* out, int* in, short* coeff, int* state, int n)
;-----------------------------------------
; On Entrance
; r0 - *out
; r1 - *in
; r2 - *coeff
; r3 - *state
; Stack - n
;-----------------------------------------
; r0 - *out
; r1 - *in
; r2 - data
; r3 - *state
; r5 - b0
; r6 - b2/b1
; r7 - a2/a1
; r8 - st1
; r9 - st2
; r10 - outdata
; r11 - 
; r12 - outdata
; r13 - Stack
; r14 - n
;-----------------------------------------

QCOEFF		EQU 13

	EXPORT	Biquad_proc
	
Biquad_proc

;   // debug
	STR	r4, [sp,#(LateReverb_SP_pd0)]

	stmfd sp!, {r4-r11,lr}

	; load coeffs
	ldrh	r5, [r2], #2
	ldrh	r6, [r2], #2
	ldrh	r7, [r2], #2
	orr		r6, r6, r7, lsl#16
	ldrh	r7, [r2], #2
	ldrh	r8, [r2], #2
	orr		r7, r7, r8, lsl#16
	
	; load states
	ldmia	r3, {r8-r9}
	
	; load counter
	ldr	r14, [sp,#4*9]
	
biquad_Loop

	ldrsh	r2, [r1],#2*2
	smlawb	r2, r8, r7, r2
	smlawt	r2, r9, r7, r2
	smulwb	r12, r8, r6
	smlawt	r12, r9, r6, r12
	mov		r2, r2, lsl#(16-QCOEFF)
	smlawb	r12, r2, r5, r12
	strh	r12, [r0],#2*2

	mov		r9, r8				; update states
	mov		r8, r2
	
	subs r14, r14, #1
	bgt biquad_Loop
	
	; save states
	stmia	r3, {r8-r9}

	ldmfd sp!, {r4-r11,pc}
	
	
	END
