//[C++] 

//TBD:
// - command line
// - fill Macros table
//* - starting declaration (#define sp r13 etc)
//* - handling of number of parameters (manually)
//* - reading macros - skip empty lines
//* - handling stack (introduce stack array at the start of the function)

#include <vcclr.h>

#using <System.Windows.Forms.DLL>

using namespace System;
using namespace System::IO;
using namespace System::Collections::Generic;
using namespace System::Windows::Forms;

// Tables for asm->C translation
struct ArmAsm{
	// instruction
	gcroot< List<String^>^ > ARMinstr;
	gcroot< List<String^>^ > ARMpattern;
	// operand2
	gcroot< List<String^>^ > OP2instr;
	gcroot< List<String^>^ > OP2pattern;
	// operand2
	gcroot< List<String^>^ > CONDinstr;
	gcroot< List<String^>^ > CONDpattern;
} aa;

struct Patterns{
	gcroot< List<String^>^ > ARMpat;
	gcroot< List<String^>^ > Cpat;
} pp;

gcroot< List<String^>^ > FuncList;

gcroot< String^ > ARM_funcstart;

gcroot<array<Char>^> sep;

// Reading command line
gcroot<String^> InFileName="";
gcroot<String^> OutFileName="";

bool OrigInstr_To_Comments=false;
bool Print_OrigComments=false;



String^ ParseInstruction(String^ code, int opidx);

String^ ReplaceOperands(String^ code, String^ asmpattern, String^ Cpattern)
{
	String^ Cstring=Cpattern;

	// split into required number of operands
//	array<Char>^ sep = gcnew array<Char>{ ',',  ' ',  '.', '\t', ':', '#'};
	array<String^>^ asmpattern_operands = asmpattern->Split( sep, StringSplitOptions::RemoveEmptyEntries );
	int len=asmpattern_operands->Length;
	array<String^>^ code_operands = code->Split( sep, len, StringSplitOptions::RemoveEmptyEntries );
		// quick fix (for the case LDR r14,[sp,#4*9])
		code_operands[len-1]=code_operands[len-1]->Replace("]","");

	// replace operands in pattern (simple operand-by-operand replacement)
	System::Collections::IEnumerator^ asmpattern_enum = asmpattern_operands->GetEnumerator();
	System::Collections::IEnumerator^ code_enum  = code_operands->GetEnumerator();
	while( asmpattern_enum->MoveNext() && code_enum->MoveNext() )
	{
		String^ asmop=safe_cast<String^>(asmpattern_enum->Current);
		String^ codeop=safe_cast<String^>(code_enum->Current);

		if (asmop->Contains("^"))
		{
			int idx=asmop->IndexOf("^");
			String^ ioprnd=asmop->Substring(idx,2);						// it will be replaced
			
			String^ aoprnd;												// by this content

			array<String^>^ ops=codeop->Split( sep, StringSplitOptions::RemoveEmptyEntries );

			if ( asmop->Contains("a") && (ops->Length > 1) )
					aoprnd=ParseInstruction(codeop, 2);
			else
			{
				int dst=asmop->Length-idx;
				aoprnd=codeop->Substring(idx,codeop->Length-dst+2);
			}
			Cstring=Cstring->Replace(ioprnd,aoprnd);
		}
			   
	}

	return Cstring;
}

// reading pattern tables,
// finding all matches to the 'op0' code word
// find maximum matching in case of multiple matching (now - LDR and STR like instructions)
void FindCodePattern(String^ op0,List<String^>^ asmpattern_table, List<String^>^ Cpattern_table, int opidx)
{
	pp.ARMpat->Clear();//="";
	pp.Cpat->Clear();//="";

	System::Collections::IEnumerator^ asmpattern_enum = asmpattern_table->GetEnumerator();
	System::Collections::IEnumerator^ Cpattern_enum = Cpattern_table->GetEnumerator();
	// starting to search through the table
	while ( asmpattern_enum->MoveNext() && Cpattern_enum->MoveNext() )
	{
		String^ asmpattern = safe_cast<String^>(asmpattern_enum->Current);

		// split to operands
		array<String^>^ ops = asmpattern->Split(sep,StringSplitOptions::RemoveEmptyEntries);

		// check operand matching
		if (String::Compare(ops[opidx-1],op0)==0)
		{	// found instruction pattern
			//pp.ARMpat=asmpattern;
			//pp.Cpat=safe_cast<String^>(Cpattern_enum->Current);
			//asmpatmatch->Add(asmpattern);
			//Cpatmatch->Add(safe_cast<String^>(Cpattern_enum->Current));

			pp.ARMpat->Add(asmpattern);
			pp.Cpat->Add(safe_cast<String^>(Cpattern_enum->Current));

//			break;
		}
	}
}

int FindFullMatchedPattern(String^ code, Patterns* pat)
{
	int idx=0;

	String^ CodeUp=code->ToUpper();

	// replace multiple operands in curves (if curves present - LDM & STM case)
	int opencrv_idx=CodeUp->IndexOf("{");	int closecrv_idx=CodeUp->IndexOf("}");
	if (opencrv_idx>=0)
	{
		String^ s=CodeUp->Substring(opencrv_idx+1,closecrv_idx-opencrv_idx-1);
		CodeUp=CodeUp->Replace(s,"xxx");
	}

	// split parsed code onto operands
	array<Char>^ sep = gcnew array<Char>{ ',',  ' ',  '.', '\t', ':', /*'#',*/ '[', ']','{', '}','!'};
	
		array<String^>^ code_operands = CodeUp->Split( sep, StringSplitOptions::RemoveEmptyEntries );
		array<String^>^ code_separators = CodeUp->Split( code_operands, StringSplitOptions::RemoveEmptyEntries );

	// search matching in the loop
	System::Collections::IEnumerator^ asm_enum = pat->ARMpat->GetEnumerator();
	while (asm_enum->MoveNext())
	{
		String^ code1=CodeUp;

		String^ asmcode=safe_cast<String^>(asm_enum->Current);
		// split asm pattern onto operands
		array<String^>^ armops= asmcode->Split(sep, StringSplitOptions::RemoveEmptyEntries);

		//// split code to the same number of operands (removing brackets before)
		//String^ CodeUp1=CodeUp->Replace("[","");CodeUp1=CodeUp1->Replace("]","");
		//		CodeUp1=CodeUp1->Replace("{","");CodeUp1=CodeUp1->Replace("}","");
		//array<String^>^ code_operands = CodeUp1->Split( sep, armops->Length, StringSplitOptions::RemoveEmptyEntries );
		//array<String^>^ code_separators = CodeUp->Split( code_operands, StringSplitOptions::RemoveEmptyEntries );

		// remove true operands marked by "^" (replace by empty space)
		System::Collections::IEnumerator^ codeops_enum = code_operands->GetEnumerator();
		System::Collections::IEnumerator^ armops_enum  = armops->GetEnumerator();

		int opidx=0;
		String^ oprnd;
		bool bool_code;
		while((bool_code=codeops_enum->MoveNext()) && armops_enum->MoveNext())
		{
			oprnd=safe_cast<String^>(armops_enum->Current);
			if (oprnd->IndexOf("^")==0)
			{
				//// remove this operator from code
				code_operands[opidx]="";
				//// and from asm pattern
				asmcode=asmcode->Replace(oprnd,"");
			}
			opidx++;
		};

		// if last operand is 'op2', clear remaining operands and separators between them
		array<String^>^ code_separators_tmp = code_separators ;
//		if (oprnd->IndexOf("^a")==0)
		if (String::Compare(oprnd,"^a") == 0)
		{
//			String^ s_tmp;
			if (bool_code)
			{
				do {
	//				s_tmp=code_separators_tmp[opidx];
					code_separators_tmp[opidx-1]="";
					code_operands[opidx++]="";
				} while (codeops_enum->MoveNext());
			}
			// restore last separator
//			code_separators_tmp[opidx]=s_tmp;
		}

		// interleaved combine 'code_operands' and 'code_separators'
		System::Collections::IEnumerator^ code_operands_enum   = code_operands->GetEnumerator();
		System::Collections::IEnumerator^ code_separators_enum = code_separators->GetEnumerator();
		code1="";
		int i;
		for (i=0;i<(code_operands->Length + code_separators->Length);i++)
//		while ( (code_operands_enum->MoveNext()) && (code_operands_enum->MoveNext()) )
		{
			if (i%2==0)
			{
				code_operands_enum->MoveNext();
				code1+=code_operands_enum->Current;
			}
			else
			{
				code_separators_enum->MoveNext();
				code1+=code_separators_enum->Current;
			}
		}

		// remove all spaces, all tabs, all commas
		code1=code1->Replace(" ","");		code1=code1->Replace("\t","");		//code1=code1->Replace(",","");
		asmcode=asmcode->Replace(" ","");	asmcode=asmcode->Replace("\t","");	//asmcode=asmcode->Replace(",","");

		// if patterns are equal - we found full matching
		if (String::Compare(code1,asmcode)==0)
		{
			//asmpattern=safe_cast<String^>(asm_enum->Current);
			//Cpattern=safe_cast<String^>(C_enum->Current);
			return idx;
		}
		
		idx++;
	}

	return idx;
}

// parse operand array inside of curves for LDM/STM instructions
// !!! doesnt check increasing order (could be problematic for unordered operand sequence)
List<String^>^ GetOperandArray(String^ inoprnd)
{
	List<String^>^ oplist = gcnew List<String^>();

	// split by subparts using ","
	array<Char>^ sp = gcnew array<Char>{','};
	array<String^>^ ops = inoprnd->Split(sp,StringSplitOptions::RemoveEmptyEntries);

	// loop for subparts
	System::Collections::IEnumerator^ ops_enum  = ops->GetEnumerator();
	while (ops_enum->MoveNext())
	{
		String^ op=safe_cast<String^>(ops_enum->Current);
		// split using "-"
		array<Char>^ sp = gcnew array<Char>{'-'};
		array<String^>^ r = op->Split(sp,StringSplitOptions::RemoveEmptyEntries);

		if (r->Length > 1)
		{
			// extract registers numbers
			String^ s=r[0]; s=s->ToUpper(); s=s->Replace("R","");
			int start_idx=Convert::ToInt32(s);
					s=r[1]; s=s->ToUpper(); s=s->Replace("R","");
			int stop_idx=Convert::ToInt32(s);

			// fill list by operands
			for (int i=start_idx;i<=stop_idx;i++)
				oplist->Add("r" + Convert::ToString(i) );
		}
		else
		{
			oplist->Add(r[0]);
		}
	}

	return(oplist);
}

// replace operands in LDM/STM instructions
String^ ReplaceOperandsLDM(String^ code, String^ asmpattern, String^ Cpattern)
{
	// Cpattern, code:	extract place between internal curves
	int opencrv_idx=code->IndexOf("{");	int closecrv_idx=code->IndexOf("}");
	String^ inoprnd=code->Substring(opencrv_idx+1,closecrv_idx-opencrv_idx-1);
	String^ code1=code->Replace(inoprnd,"xxx");

	opencrv_idx=asmpattern->IndexOf("{");	closecrv_idx=asmpattern->IndexOf("}");
	String^ inasmop=asmpattern->Substring(opencrv_idx+1,closecrv_idx-opencrv_idx-1);

		// find internal curves
	opencrv_idx=Cpattern->LastIndexOf("{");
	closecrv_idx=Cpattern->Substring(opencrv_idx+1,Cpattern->Length-(opencrv_idx+1))->IndexOf("}");
	closecrv_idx+=opencrv_idx+1;
	String^ inCpat=Cpattern->Substring(opencrv_idx+1,closecrv_idx-opencrv_idx-1);
	String^ outCpat=Cpattern->Replace(inCpat,"");

	// loop for creation multiple load
		// array of operands
		List<String^>^ op_array = GetOperandArray(inoprnd);

		// reverse list for LDM/STM instructions with decremented pointer
		if (Cpattern->IndexOf("-=")>=0)
			op_array->Reverse();

		// replace in the loop
		String^ InString="\n";
		System::Collections::IEnumerator^ op_array_enum = op_array->GetEnumerator();
		while(op_array_enum->MoveNext())
		{
			String^ op=safe_cast<String^>(op_array_enum->Current);
			InString=InString+"\n"+(inCpat->Replace(inasmop,op));
		}
		InString=InString+"\n";

	// insert internal part into outer one
	int idx=outCpat->LastIndexOf("{");
	String^ OutString=outCpat->Insert(idx+1,InString);

	// replace remaining operands
	OutString=ReplaceOperands(code1,asmpattern,OutString);

	return (OutString);
}

// find corresponding instruction pattern in the instruction-pattern table 
String^ ParseInstruction(String^ code, int opidx)
{
	String^ Cstring="";
	String^ s="";
	String^ condexpr="";

	// separate to the operands
//	array<Char>^ sep = gcnew array<Char>{ ',',  ' ',  '.', '\t', ':', '#' };
//	if (opidx!=1) sep::IList::Add('#');
	array<String^>^ code_operands = code->Split( sep, StringSplitOptions::RemoveEmptyEntries );

	if (code_operands->Length>0)
	{   // parsing of ASM code

	// analyze first operand
		// upcase
		String^ op0=code_operands[opidx-1];
		String^ op1=op0;
		op0=op0->ToUpper();


		//// extract condition suffix and flag suffix
		if ( (opidx==1)
			&& (String::Compare(op0,"TEQ")!=0) )	// quick fix for TEQ instr
		{
			// extract condition suffix
			if (op0->Length>2) {
				String^ cond=op0->Substring(op0->Length-2,2);
				FindCodePattern(cond,aa.CONDinstr,aa.CONDpattern,1);
	//			condexpr=pp.Cpat;
	//			if (condexpr->Length>0)
				if (pp.Cpat->Count>0)
				{
					condexpr=pp.Cpat->ToArray()[0];
					op0=op0->Substring(0,op0->Length-2);	// trim end operand by 2 symbols
				}
			}
			// extract flag suffix
			String^ suff=op0->Substring(op0->Length-1,1);
			if (String::Compare(suff,"S")==0)
			{
				s = "s="+code_operands[1]+";";
				op0=op0->Substring(0,op0->Length-1);	// trim operand by 1 symbol
			}
		}

		FindCodePattern (op0, (opidx==1) ? aa.ARMinstr:aa.OP2instr,
							  (opidx==1) ? aa.ARMpattern:aa.OP2pattern, opidx);

		String^ asmpattern/*=pp.ARMpat*/;
		String^ Cpattern/*=pp.Cpat*/;

		if (pp.ARMpat->Count > 0)
		{	// found instruction pattern
			int idx=0;

			if ( pp.ARMpat->Count > 1 )
			{	/// load and store instructions have multiple syntax
				
				// replace original operator with operator without suffixes and flags
				int k=code->IndexOf(op1);
				String^ code1=code->Remove(k,op1->Length);
				code1=code1->Insert(k,op0);

				idx=FindFullMatchedPattern(code1,&pp);
					// check idx needed?   if idx>pp->Length,  error - no full matching
			}

			asmpattern=pp.ARMpat->ToArray()[idx];
			Cpattern=pp.Cpat->ToArray()[idx];

			// replace operands in Cpattern according to code and asmpattern
			if ((op0->IndexOf("LDM")==0) || (op0->IndexOf("STM")==0) )
			{   // process LDM/STM
				Cstring=ReplaceOperandsLDM(code, asmpattern, Cpattern);
			}
			else
			{
				// replace operands in pattern
				Cstring=ReplaceOperands(code, asmpattern, Cpattern);
			}

			//break;	// stop finding next instruction pattern

		}

	}

	if (Cstring->Length > 0)
	{	// if instruction was decode successfully, add code corresponding to the conditions and flags
		// else empty line will return indicating unsuccessfull parsing
		
		// combine expressions : condition + instruction + flag
		Cstring=Cstring+s;
		if (condexpr->Length > 0)
			Cstring=condexpr+"{"+Cstring+"}";

	}

	return Cstring; 
}

bool LabelIsFunction(String^ label)
{
//	bool isfunc=FALSE;

	System::Collections::IEnumerator^ func_enum = FuncList->GetEnumerator();
	while(func_enum->MoveNext())
	{
		String^ s= safe_cast<String^>(func_enum->Current);
		if (String::Compare(label,s)==0)
			return true;
	}

	return false;
}

String^ WriteFunctionStart(String^ label)
{
	String^ outS="";

    StreamReader^ sr = gcnew StreamReader(ARM_funcstart);
    String^ line;

	while ((line = sr->ReadLine()) != nullptr)
    {
		line=line->Replace("^1",label);
		outS+=line+"\n";
    }
    sr->Close();

	return outS;
}

// splitting string onto "code" and "comment"
String^ AnalyzeLine(String^ line/*, List<String^>^ arminstr, List<String^>^ macr*/)
{
	// extract comments from the line
//	array<Char>^sep = gcnew array<Char>{      ',',  ' ',  '.', '\t', ':'   };
	array<Char>^ sp = gcnew array<Char>{ ';' };
	array<String^>^ result = line->Split( sp, 2, StringSplitOptions::None  );

	String^ Cline="";

	if (result->Length > 0)
	{
		if (result->Length==2)
		{	// get comment line
			String^ comment = result[1];
			if (!String::IsNullOrEmpty(comment))
			{
				// write comments before the code
				Cline = "//" + comment + "\n";
			}
		}

		// get code string
		String^ code = result[0];
//		code=code->Trim({' ','\t'});
		if (code->Length>0)
		{	
			if (code[0]==' ' || code[0]=='\t')
			{	// tab or space first present
				// this codeword of preprocessor statement

				code=code->Trim(' ','\t');
//				String^ codeUp=code->ToUpper();
				/* check whether it is preprocessor statement */
				if (code->ToUpper()->IndexOf("EXPORT")==0)
				{
					// List label after EXTERN into FuncList list
					array<Char>^ sp=gcnew array<Char>{' ','\t'};
					array<String^>^ ops=code->Split(sp,StringSplitOptions::RemoveEmptyEntries);
//					String^ s=safe_cast<String^>(ops[1]);
					FuncList->Add(ops[1]);
				}
				else if (code->ToUpper()->IndexOf("END")==0)
				{
					// do nothing
				}
				else
				{
					String^ cpat;
					/* parse ARM code */
					try{
						 cpat=ParseInstruction(code,1);
					}
					catch (Exception^ p) {
						 Console::WriteLine(p);
						 cpat="";
					}

					if ((cpat->Length == 0) && (/*(code->Trim(' ','\t'))*/code->Length != 0))
						cpat="ERROR !!! ->  " + code + "  <- this line is not recognized";
					Cline=Cline + cpat + "\n";
				}
			}
			else
			{	// this is label or definition
				array<String^>^ ops=code->Split( sep, StringSplitOptions::RemoveEmptyEntries );
				int IsProc = false;
				if ( ops->Length > 1)
					IsProc = (String::Compare(ops[1],"PROC")==0) || (String::Compare(ops[1],"proc")==0);

				if ( (ops->Length > 1) && ( ! IsProc ) )
					Cline=ParseInstruction(code, 2)+"\n";		// this is preprocessor instruction
				else
				{
					if (LabelIsFunction(ops[0]) || IsProc)
					{
						// write function header (declaration and start of function)
						Cline=WriteFunctionStart(ops[0]);
					}
					else
						Cline=code+":\n";						// this is label
				}

				// if not known codeword - then possibly preprocessor condition
			}
		}
	}

	// add function ending code if necessary
	String^ s=Cline->Replace(" ","");s=s->Replace("\t","");
	if (s->IndexOf("pc=")>=0)
	{
		Cline+="\nreturn r0;\n}\n";
	}

	return Cline;
}


List<String^>^ ReadMacrosFile(String^ fname, int idx)
{
	List<String^>^ macros = gcnew List<String^>();
	StreamReader^ sr = gcnew StreamReader(fname);
	String^ line;

	array<Char>^sep = gcnew array<Char>{ ';' };

	while ((line = sr->ReadLine()) != nullptr)
        {
			// is it comment? (comments starts from '#')
			line = line->Trim(' ','\t');
			if (line->IndexOf("#") != 0)	//	Fill table if diez sign is not at the first position
			{
				// separate by semicolon
				array<String^>^ result = line->Split( sep, 2, StringSplitOptions::None  );
				if (result->Length>=2)			// pass empty lines
					macros->Add(result[idx]->Trim(' ','\t'));
			}
        }
    sr->Close();

	return macros;
}

void Init(void)
{
	String^ cmd=Application::StartupPath;
	cmd=cmd->Substring(0,cmd->LastIndexOf("\\"));

	String^ dir=cmd+"\\Macroses\\";

	String^ ARM_Macr=dir+"ARM_Macroses.txt";
	String^ ARM_op2 =dir+"ARM_Shifts.txt";
	String^ ARM_cond=dir+"ARM_Conditions.txt";

	ARM_funcstart=dir+"ARM_FunctionStart.txt";

	// read ARM instructions, read C macroses
	aa.ARMinstr   =ReadMacrosFile(ARM_Macr,0);
	aa.ARMpattern =ReadMacrosFile(ARM_Macr,1);
	aa.OP2instr   =ReadMacrosFile(ARM_op2,0);
	aa.OP2pattern =ReadMacrosFile(ARM_op2,1);
	aa.CONDinstr  =ReadMacrosFile(ARM_cond,0);
	aa.CONDpattern=ReadMacrosFile(ARM_cond,1);

	pp.ARMpat=gcnew List<String^>();
	pp.Cpat=gcnew List<String^>();

	FuncList=gcnew List<String^>();

	sep = gcnew array<Char>{ ',',  ' ',  '.', '\t', ':', '#', '[', ']', '{', '}'};
}

void ARM2C_PrintHelp(void)
{
	Console::WriteLine("ARM2C usage:\n");
	Console::WriteLine("ARM2C -iInFileName.s [-oOutFileName.c] [-q] [-w]\n");
	Console::WriteLine("\n");
	Console::WriteLine("-i or -I   - input  file name\n");
	Console::WriteLine("-o or -O   - output file name  (if skipped, outputfile name will be made as InFileName.c)\n");
	Console::WriteLine("-q         - insert original instructions to comments (not inserted if skipped) (now skipped regardless of parameter)\n");
	Console::WriteLine("-w         - insert original comments to the code (not inserted if skipped) (now inserted regardless of parameter)\n");
}

int ProcessCLParameters(int argc, char *argv[])
{
	int i;

	// first exeption case
	if (argc<2)
	{
		ARM2C_PrintHelp();
		return -1;
	}

	// read arguments
	for(i = 1; i < argc; i++)
	{
		String^ cmd=gcnew String(argv[i]);

		if (cmd->ToUpper()->IndexOf("-I")==0)
		{
			if (cmd->Length>2)
			{ // extract file name from the same argument
				InFileName=cmd->Substring(2,cmd->Length-2);
			}
			else
			{ // read next argument
				i++;
				InFileName=gcnew String(argv[i]);
			}
		}
		else if (cmd->ToUpper()->IndexOf("-O")==0)
		{
			if (cmd->Length>2)
			{ // extract file name from the same argument
				OutFileName=cmd->Substring(2,cmd->Length-2);
			}
			else
			{ // read next argument
				i++;
				OutFileName=gcnew String(argv[i]);
			}
		}
		else if (String::Compare(cmd->ToUpper(),"-q"))
		{
			OrigInstr_To_Comments=true;
		}
		else if (String::Compare(cmd->ToUpper(),"-w"))
		{
			Print_OrigComments=true;
		}
	}

	// check exeption cases
	if (InFileName->Length==0)
	{
		ARM2C_PrintHelp();
		return -1;
	}
	if (OutFileName->Length==0)
	{	// replace input file name extension by ".c"
		int idx=InFileName->LastIndexOf(".");
		OutFileName=InFileName->Substring(0,idx)+".c";
	}

	return 0;
}

int main(int argc, char *argv[])
{

	Init();

	if (ProcessCLParameters(argc, argv) < 0)
		return -1;

    try
    {
        // Create an instance of StreamReader to read from a file.
        // The using statement also closes the StreamReader.
        StreamReader^ sr = gcnew StreamReader(InFileName/*"biquad.s"*/);
        String^ line;
        // Read and display lines from the file until the end of
        // the file is reached.

		StreamWriter^ outfile = gcnew StreamWriter(OutFileName/*"out.txt"*/);

		outfile->Write("#include \"ARM_to_C.h\"\n");

        while ((line = sr->ReadLine()) != nullptr)
        {
			// debug
			Console::WriteLine(line);

			String^ Cl=AnalyzeLine( line/*, ARMinstr, macros*/ );
			outfile->Write(Cl);
        }
        sr->Close();
        outfile->Close();
    }
    catch (Exception^ e)
    {
        // Let the user know what went wrong.
        Console::WriteLine(e/*"The file could not be read:"*/);
//        Console::WriteLine(e->Message);
    }

}
